<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Location_Customer_Account_Number_DetailObjectType
 * StructType
 * @subpackage Structs
 */
class Location_Customer_Account_Number_DetailObjectType extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Location_Customer_Account_Number_DetailObjectIDType[]
     */
    public $ID;
    /**
     * The Descriptor
     * Meta information extracted from the WSDL
     * - documentation: Display information used to describe an instance of an object. This 'optional' information is for outbound descriptive purposes only and is not processed on inbound Workday Web Services requests.
     * @var string
     */
    public $Descriptor;
    /**
     * Constructor method for Location_Customer_Account_Number_DetailObjectType
     * @uses Location_Customer_Account_Number_DetailObjectType::setID()
     * @uses Location_Customer_Account_Number_DetailObjectType::setDescriptor()
     * @param \StructType\Location_Customer_Account_Number_DetailObjectIDType[] $iD
     * @param string $descriptor
     */
    public function __construct(array $iD = array(), $descriptor = null)
    {
        $this
            ->setID($iD)
            ->setDescriptor($descriptor);
    }
    /**
     * Get ID value
     * @return \StructType\Location_Customer_Account_Number_DetailObjectIDType[]|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * This method is responsible for validating the values passed to the setID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIDForArrayConstraintsFromSetID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $location_Customer_Account_Number_DetailObjectTypeIDItem) {
            // validation for constraint: itemType
            if (!$location_Customer_Account_Number_DetailObjectTypeIDItem instanceof \StructType\Location_Customer_Account_Number_DetailObjectIDType) {
                $invalidValues[] = is_object($location_Customer_Account_Number_DetailObjectTypeIDItem) ? get_class($location_Customer_Account_Number_DetailObjectTypeIDItem) : sprintf('%s(%s)', gettype($location_Customer_Account_Number_DetailObjectTypeIDItem), var_export($location_Customer_Account_Number_DetailObjectTypeIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ID property can only contain items of type \StructType\Location_Customer_Account_Number_DetailObjectIDType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ID value
     * @throws \InvalidArgumentException
     * @param \StructType\Location_Customer_Account_Number_DetailObjectIDType[] $iD
     * @return \StructType\Location_Customer_Account_Number_DetailObjectType
     */
    public function setID(array $iD = array())
    {
        // validation for constraint: array
        if ('' !== ($iDArrayErrorMessage = self::validateIDForArrayConstraintsFromSetID($iD))) {
            throw new \InvalidArgumentException($iDArrayErrorMessage, __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Add item to ID value
     * @throws \InvalidArgumentException
     * @param \StructType\Location_Customer_Account_Number_DetailObjectIDType $item
     * @return \StructType\Location_Customer_Account_Number_DetailObjectType
     */
    public function addToID(\StructType\Location_Customer_Account_Number_DetailObjectIDType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Location_Customer_Account_Number_DetailObjectIDType) {
            throw new \InvalidArgumentException(sprintf('The ID property can only contain items of type \StructType\Location_Customer_Account_Number_DetailObjectIDType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ID[] = $item;
        return $this;
    }
    /**
     * Get Descriptor value
     * @return string|null
     */
    public function getDescriptor()
    {
        return $this->Descriptor;
    }
    /**
     * Set Descriptor value
     * @param string $descriptor
     * @return \StructType\Location_Customer_Account_Number_DetailObjectType
     */
    public function setDescriptor($descriptor = null)
    {
        // validation for constraint: string
        if (!is_null($descriptor) && !is_string($descriptor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptor, true), gettype($descriptor)), __LINE__);
        }
        $this->Descriptor = $descriptor;
        return $this;
    }
}
